import json
import unittest
from mstrio.utils.parsejson import parsejson


def get_response():
    response = '{"id":"E414706011E82EDC08230080EF45A2CD","name":"iris.csv","instanceId":"B929CAF411E84C8BB1B90080EF157039","result":{"definition":{"attributes":[{"name":"ID","id":"D91B4BDE11E82EDC13FC0080EF25E205","type":"Attribute","forms":[{"id":"45C11FA478E745FEA08D781CEA190FE5","name":"ID","dataType":"Real"}]},{"name":"Species","id":"D91B6E0311E82EDC1D720080EF25E205","type":"Attribute","forms":[{"id":"45C11FA478E745FEA08D781CEA190FE5","name":"ID","dataType":"Char"}]}],"metrics":[{"name":"Petal.Length","id":"D91B615011E82EDC18D50080EF25E205","type":"Metric","min":1,"max":6.9,"numberFormatting":{"category":9,"formatString":"General"}},{"name":"Petal.Width","id":"D91B683A11E82EDC1D710080EF25E205","type":"Metric","min":0.1,"max":2.5,"numberFormatting":{"category":9,"formatString":"General"}},{"name":"RowCount-iris.csv","id":"D8F6727811E82EDC4FF10080EFF503CE","type":"Metric","min":1,"max":1,"numberFormatting":{"category":0,"decimalPlaces":0,"formatString":"#,##0;(#,##0)"}},{"name":"Sepal.Length","id":"D91B532C11E82EDC13FC0080EF25E205","type":"Metric","min":4.3,"max":7.9,"numberFormatting":{"category":9,"formatString":"General"}},{"name":"Sepal.Width","id":"D91B5B5611E82EDC140F0080EF25E205","type":"Metric","min":2,"max":4.4,"numberFormatting":{"category":9,"formatString":"General"}}],"thresholds":[]},"data":{"paging":{"total":150,"current":150,"offset":0,"limit":1000,"prev":null,"next":null},"root":{"isPartial":false,"children":[{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"1"},"name":"1","id":"h1;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.4,"fv":"1.4","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.1,"fv":"5.1","mi":3},"Sepal.Width":{"rv":3.5,"fv":"3.5","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"2"},"name":"2","id":"h2;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.4,"fv":"1.4","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":4.9,"fv":"4.9","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"3"},"name":"3","id":"h3;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.3,"fv":"1.3","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":4.7,"fv":"4.7","mi":3},"Sepal.Width":{"rv":3.2,"fv":"3.2","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"4"},"name":"4","id":"h4;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.5,"fv":"1.5","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":4.6,"fv":"4.6","mi":3},"Sepal.Width":{"rv":3.1,"fv":"3.1","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"5"},"name":"5","id":"h5;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.4,"fv":"1.4","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5,"fv":"5","mi":3},"Sepal.Width":{"rv":3.6,"fv":"3.6","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"6"},"name":"6","id":"h6;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.7,"fv":"1.7","mi":0},"Petal.Width":{"rv":0.4,"fv":"0.4","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.4,"fv":"5.4","mi":3},"Sepal.Width":{"rv":3.9,"fv":"3.9","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"7"},"name":"7","id":"h7;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.4,"fv":"1.4","mi":0},"Petal.Width":{"rv":0.3,"fv":"0.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":4.6,"fv":"4.6","mi":3},"Sepal.Width":{"rv":3.4,"fv":"3.4","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"8"},"name":"8","id":"h8;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.5,"fv":"1.5","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5,"fv":"5","mi":3},"Sepal.Width":{"rv":3.4,"fv":"3.4","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"9"},"name":"9","id":"h9;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.4,"fv":"1.4","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":4.4,"fv":"4.4","mi":3},"Sepal.Width":{"rv":2.9,"fv":"2.9","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"10"},"name":"10","id":"h10;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.5,"fv":"1.5","mi":0},"Petal.Width":{"rv":0.1,"fv":"0.1","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":4.9,"fv":"4.9","mi":3},"Sepal.Width":{"rv":3.1,"fv":"3.1","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"11"},"name":"11","id":"h11;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.5,"fv":"1.5","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.4,"fv":"5.4","mi":3},"Sepal.Width":{"rv":3.7,"fv":"3.7","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"12"},"name":"12","id":"h12;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.6,"fv":"1.6","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":4.8,"fv":"4.8","mi":3},"Sepal.Width":{"rv":3.4,"fv":"3.4","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"13"},"name":"13","id":"h13;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.4,"fv":"1.4","mi":0},"Petal.Width":{"rv":0.1,"fv":"0.1","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":4.8,"fv":"4.8","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"14"},"name":"14","id":"h14;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.1,"fv":"1.1","mi":0},"Petal.Width":{"rv":0.1,"fv":"0.1","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":4.3,"fv":"4.3","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"15"},"name":"15","id":"h15;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.2,"fv":"1.2","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.8,"fv":"5.8","mi":3},"Sepal.Width":{"rv":4,"fv":"4","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"16"},"name":"16","id":"h16;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.5,"fv":"1.5","mi":0},"Petal.Width":{"rv":0.4,"fv":"0.4","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.7,"fv":"5.7","mi":3},"Sepal.Width":{"rv":4.4,"fv":"4.4","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"17"},"name":"17","id":"h17;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.3,"fv":"1.3","mi":0},"Petal.Width":{"rv":0.4,"fv":"0.4","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.4,"fv":"5.4","mi":3},"Sepal.Width":{"rv":3.9,"fv":"3.9","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"18"},"name":"18","id":"h18;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.4,"fv":"1.4","mi":0},"Petal.Width":{"rv":0.3,"fv":"0.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.1,"fv":"5.1","mi":3},"Sepal.Width":{"rv":3.5,"fv":"3.5","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"19"},"name":"19","id":"h19;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.7,"fv":"1.7","mi":0},"Petal.Width":{"rv":0.3,"fv":"0.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.7,"fv":"5.7","mi":3},"Sepal.Width":{"rv":3.8,"fv":"3.8","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"20"},"name":"20","id":"h20;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.5,"fv":"1.5","mi":0},"Petal.Width":{"rv":0.3,"fv":"0.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.1,"fv":"5.1","mi":3},"Sepal.Width":{"rv":3.8,"fv":"3.8","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"21"},"name":"21","id":"h21;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.7,"fv":"1.7","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.4,"fv":"5.4","mi":3},"Sepal.Width":{"rv":3.4,"fv":"3.4","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"22"},"name":"22","id":"h22;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.5,"fv":"1.5","mi":0},"Petal.Width":{"rv":0.4,"fv":"0.4","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.1,"fv":"5.1","mi":3},"Sepal.Width":{"rv":3.7,"fv":"3.7","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"23"},"name":"23","id":"h23;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1,"fv":"1","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":4.6,"fv":"4.6","mi":3},"Sepal.Width":{"rv":3.6,"fv":"3.6","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"24"},"name":"24","id":"h24;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.7,"fv":"1.7","mi":0},"Petal.Width":{"rv":0.5,"fv":"0.5","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.1,"fv":"5.1","mi":3},"Sepal.Width":{"rv":3.3,"fv":"3.3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"25"},"name":"25","id":"h25;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.9,"fv":"1.9","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":4.8,"fv":"4.8","mi":3},"Sepal.Width":{"rv":3.4,"fv":"3.4","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"26"},"name":"26","id":"h26;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.6,"fv":"1.6","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5,"fv":"5","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"27"},"name":"27","id":"h27;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.6,"fv":"1.6","mi":0},"Petal.Width":{"rv":0.4,"fv":"0.4","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5,"fv":"5","mi":3},"Sepal.Width":{"rv":3.4,"fv":"3.4","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"28"},"name":"28","id":"h28;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.5,"fv":"1.5","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.2,"fv":"5.2","mi":3},"Sepal.Width":{"rv":3.5,"fv":"3.5","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"29"},"name":"29","id":"h29;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.4,"fv":"1.4","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.2,"fv":"5.2","mi":3},"Sepal.Width":{"rv":3.4,"fv":"3.4","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"30"},"name":"30","id":"h30;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.6,"fv":"1.6","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":4.7,"fv":"4.7","mi":3},"Sepal.Width":{"rv":3.2,"fv":"3.2","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"31"},"name":"31","id":"h31;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.6,"fv":"1.6","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":4.8,"fv":"4.8","mi":3},"Sepal.Width":{"rv":3.1,"fv":"3.1","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"32"},"name":"32","id":"h32;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.5,"fv":"1.5","mi":0},"Petal.Width":{"rv":0.4,"fv":"0.4","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.4,"fv":"5.4","mi":3},"Sepal.Width":{"rv":3.4,"fv":"3.4","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"33"},"name":"33","id":"h33;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.5,"fv":"1.5","mi":0},"Petal.Width":{"rv":0.1,"fv":"0.1","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.2,"fv":"5.2","mi":3},"Sepal.Width":{"rv":4.1,"fv":"4.1","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"34"},"name":"34","id":"h34;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.4,"fv":"1.4","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.5,"fv":"5.5","mi":3},"Sepal.Width":{"rv":4.2,"fv":"4.2","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"35"},"name":"35","id":"h35;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.5,"fv":"1.5","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":4.9,"fv":"4.9","mi":3},"Sepal.Width":{"rv":3.1,"fv":"3.1","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"36"},"name":"36","id":"h36;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.2,"fv":"1.2","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5,"fv":"5","mi":3},"Sepal.Width":{"rv":3.2,"fv":"3.2","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"37"},"name":"37","id":"h37;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.3,"fv":"1.3","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.5,"fv":"5.5","mi":3},"Sepal.Width":{"rv":3.5,"fv":"3.5","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"38"},"name":"38","id":"h38;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.4,"fv":"1.4","mi":0},"Petal.Width":{"rv":0.1,"fv":"0.1","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":4.9,"fv":"4.9","mi":3},"Sepal.Width":{"rv":3.6,"fv":"3.6","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"39"},"name":"39","id":"h39;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.3,"fv":"1.3","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":4.4,"fv":"4.4","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"40"},"name":"40","id":"h40;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.5,"fv":"1.5","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.1,"fv":"5.1","mi":3},"Sepal.Width":{"rv":3.4,"fv":"3.4","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"41"},"name":"41","id":"h41;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.3,"fv":"1.3","mi":0},"Petal.Width":{"rv":0.3,"fv":"0.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5,"fv":"5","mi":3},"Sepal.Width":{"rv":3.5,"fv":"3.5","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"42"},"name":"42","id":"h42;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.3,"fv":"1.3","mi":0},"Petal.Width":{"rv":0.3,"fv":"0.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":4.5,"fv":"4.5","mi":3},"Sepal.Width":{"rv":2.3,"fv":"2.3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"43"},"name":"43","id":"h43;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.3,"fv":"1.3","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":4.4,"fv":"4.4","mi":3},"Sepal.Width":{"rv":3.2,"fv":"3.2","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"44"},"name":"44","id":"h44;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.6,"fv":"1.6","mi":0},"Petal.Width":{"rv":0.6,"fv":"0.6","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5,"fv":"5","mi":3},"Sepal.Width":{"rv":3.5,"fv":"3.5","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"45"},"name":"45","id":"h45;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.9,"fv":"1.9","mi":0},"Petal.Width":{"rv":0.4,"fv":"0.4","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.1,"fv":"5.1","mi":3},"Sepal.Width":{"rv":3.8,"fv":"3.8","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"46"},"name":"46","id":"h46;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.4,"fv":"1.4","mi":0},"Petal.Width":{"rv":0.3,"fv":"0.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":4.8,"fv":"4.8","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"47"},"name":"47","id":"h47;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.6,"fv":"1.6","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.1,"fv":"5.1","mi":3},"Sepal.Width":{"rv":3.8,"fv":"3.8","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"48"},"name":"48","id":"h48;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.4,"fv":"1.4","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":4.6,"fv":"4.6","mi":3},"Sepal.Width":{"rv":3.2,"fv":"3.2","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"49"},"name":"49","id":"h49;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.5,"fv":"1.5","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.3,"fv":"5.3","mi":3},"Sepal.Width":{"rv":3.7,"fv":"3.7","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"50"},"name":"50","id":"h50;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"setosa"},"name":"setosa","id":"hsetosa;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":1.4,"fv":"1.4","mi":0},"Petal.Width":{"rv":0.2,"fv":"0.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5,"fv":"5","mi":3},"Sepal.Width":{"rv":3.3,"fv":"3.3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"51"},"name":"51","id":"h51;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.7,"fv":"4.7","mi":0},"Petal.Width":{"rv":1.4,"fv":"1.4","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":7,"fv":"7","mi":3},"Sepal.Width":{"rv":3.2,"fv":"3.2","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"52"},"name":"52","id":"h52;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.5,"fv":"4.5","mi":0},"Petal.Width":{"rv":1.5,"fv":"1.5","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.4,"fv":"6.4","mi":3},"Sepal.Width":{"rv":3.2,"fv":"3.2","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"53"},"name":"53","id":"h53;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.9,"fv":"4.9","mi":0},"Petal.Width":{"rv":1.5,"fv":"1.5","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.9,"fv":"6.9","mi":3},"Sepal.Width":{"rv":3.1,"fv":"3.1","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"54"},"name":"54","id":"h54;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4,"fv":"4","mi":0},"Petal.Width":{"rv":1.3,"fv":"1.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.5,"fv":"5.5","mi":3},"Sepal.Width":{"rv":2.3,"fv":"2.3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"55"},"name":"55","id":"h55;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.6,"fv":"4.6","mi":0},"Petal.Width":{"rv":1.5,"fv":"1.5","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.5,"fv":"6.5","mi":3},"Sepal.Width":{"rv":2.8,"fv":"2.8","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"56"},"name":"56","id":"h56;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.5,"fv":"4.5","mi":0},"Petal.Width":{"rv":1.3,"fv":"1.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.7,"fv":"5.7","mi":3},"Sepal.Width":{"rv":2.8,"fv":"2.8","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"57"},"name":"57","id":"h57;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.7,"fv":"4.7","mi":0},"Petal.Width":{"rv":1.6,"fv":"1.6","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.3,"fv":"6.3","mi":3},"Sepal.Width":{"rv":3.3,"fv":"3.3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"58"},"name":"58","id":"h58;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":3.3,"fv":"3.3","mi":0},"Petal.Width":{"rv":1,"fv":"1","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":4.9,"fv":"4.9","mi":3},"Sepal.Width":{"rv":2.4,"fv":"2.4","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"59"},"name":"59","id":"h59;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.6,"fv":"4.6","mi":0},"Petal.Width":{"rv":1.3,"fv":"1.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.6,"fv":"6.6","mi":3},"Sepal.Width":{"rv":2.9,"fv":"2.9","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"60"},"name":"60","id":"h60;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":3.9,"fv":"3.9","mi":0},"Petal.Width":{"rv":1.4,"fv":"1.4","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.2,"fv":"5.2","mi":3},"Sepal.Width":{"rv":2.7,"fv":"2.7","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"61"},"name":"61","id":"h61;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":3.5,"fv":"3.5","mi":0},"Petal.Width":{"rv":1,"fv":"1","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5,"fv":"5","mi":3},"Sepal.Width":{"rv":2,"fv":"2","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"62"},"name":"62","id":"h62;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.2,"fv":"4.2","mi":0},"Petal.Width":{"rv":1.5,"fv":"1.5","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.9,"fv":"5.9","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"63"},"name":"63","id":"h63;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4,"fv":"4","mi":0},"Petal.Width":{"rv":1,"fv":"1","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6,"fv":"6","mi":3},"Sepal.Width":{"rv":2.2,"fv":"2.2","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"64"},"name":"64","id":"h64;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.7,"fv":"4.7","mi":0},"Petal.Width":{"rv":1.4,"fv":"1.4","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.1,"fv":"6.1","mi":3},"Sepal.Width":{"rv":2.9,"fv":"2.9","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"65"},"name":"65","id":"h65;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":3.6,"fv":"3.6","mi":0},"Petal.Width":{"rv":1.3,"fv":"1.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.6,"fv":"5.6","mi":3},"Sepal.Width":{"rv":2.9,"fv":"2.9","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"66"},"name":"66","id":"h66;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.4,"fv":"4.4","mi":0},"Petal.Width":{"rv":1.4,"fv":"1.4","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.7,"fv":"6.7","mi":3},"Sepal.Width":{"rv":3.1,"fv":"3.1","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"67"},"name":"67","id":"h67;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.5,"fv":"4.5","mi":0},"Petal.Width":{"rv":1.5,"fv":"1.5","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.6,"fv":"5.6","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"68"},"name":"68","id":"h68;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.1,"fv":"4.1","mi":0},"Petal.Width":{"rv":1,"fv":"1","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.8,"fv":"5.8","mi":3},"Sepal.Width":{"rv":2.7,"fv":"2.7","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"69"},"name":"69","id":"h69;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.5,"fv":"4.5","mi":0},"Petal.Width":{"rv":1.5,"fv":"1.5","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.2,"fv":"6.2","mi":3},"Sepal.Width":{"rv":2.2,"fv":"2.2","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"70"},"name":"70","id":"h70;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":3.9,"fv":"3.9","mi":0},"Petal.Width":{"rv":1.1,"fv":"1.1","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.6,"fv":"5.6","mi":3},"Sepal.Width":{"rv":2.5,"fv":"2.5","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"71"},"name":"71","id":"h71;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.8,"fv":"4.8","mi":0},"Petal.Width":{"rv":1.8,"fv":"1.8","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.9,"fv":"5.9","mi":3},"Sepal.Width":{"rv":3.2,"fv":"3.2","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"72"},"name":"72","id":"h72;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4,"fv":"4","mi":0},"Petal.Width":{"rv":1.3,"fv":"1.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.1,"fv":"6.1","mi":3},"Sepal.Width":{"rv":2.8,"fv":"2.8","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"73"},"name":"73","id":"h73;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.9,"fv":"4.9","mi":0},"Petal.Width":{"rv":1.5,"fv":"1.5","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.3,"fv":"6.3","mi":3},"Sepal.Width":{"rv":2.5,"fv":"2.5","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"74"},"name":"74","id":"h74;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.7,"fv":"4.7","mi":0},"Petal.Width":{"rv":1.2,"fv":"1.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.1,"fv":"6.1","mi":3},"Sepal.Width":{"rv":2.8,"fv":"2.8","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"75"},"name":"75","id":"h75;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.3,"fv":"4.3","mi":0},"Petal.Width":{"rv":1.3,"fv":"1.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.4,"fv":"6.4","mi":3},"Sepal.Width":{"rv":2.9,"fv":"2.9","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"76"},"name":"76","id":"h76;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.4,"fv":"4.4","mi":0},"Petal.Width":{"rv":1.4,"fv":"1.4","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.6,"fv":"6.6","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"77"},"name":"77","id":"h77;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.8,"fv":"4.8","mi":0},"Petal.Width":{"rv":1.4,"fv":"1.4","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.8,"fv":"6.8","mi":3},"Sepal.Width":{"rv":2.8,"fv":"2.8","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"78"},"name":"78","id":"h78;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5,"fv":"5","mi":0},"Petal.Width":{"rv":1.7,"fv":"1.7","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.7,"fv":"6.7","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"79"},"name":"79","id":"h79;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.5,"fv":"4.5","mi":0},"Petal.Width":{"rv":1.5,"fv":"1.5","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6,"fv":"6","mi":3},"Sepal.Width":{"rv":2.9,"fv":"2.9","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"80"},"name":"80","id":"h80;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":3.5,"fv":"3.5","mi":0},"Petal.Width":{"rv":1,"fv":"1","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.7,"fv":"5.7","mi":3},"Sepal.Width":{"rv":2.6,"fv":"2.6","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"81"},"name":"81","id":"h81;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":3.8,"fv":"3.8","mi":0},"Petal.Width":{"rv":1.1,"fv":"1.1","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.5,"fv":"5.5","mi":3},"Sepal.Width":{"rv":2.4,"fv":"2.4","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"82"},"name":"82","id":"h82;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":3.7,"fv":"3.7","mi":0},"Petal.Width":{"rv":1,"fv":"1","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.5,"fv":"5.5","mi":3},"Sepal.Width":{"rv":2.4,"fv":"2.4","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"83"},"name":"83","id":"h83;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":3.9,"fv":"3.9","mi":0},"Petal.Width":{"rv":1.2,"fv":"1.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.8,"fv":"5.8","mi":3},"Sepal.Width":{"rv":2.7,"fv":"2.7","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"84"},"name":"84","id":"h84;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.1,"fv":"5.1","mi":0},"Petal.Width":{"rv":1.6,"fv":"1.6","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6,"fv":"6","mi":3},"Sepal.Width":{"rv":2.7,"fv":"2.7","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"85"},"name":"85","id":"h85;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.5,"fv":"4.5","mi":0},"Petal.Width":{"rv":1.5,"fv":"1.5","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.4,"fv":"5.4","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"86"},"name":"86","id":"h86;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.5,"fv":"4.5","mi":0},"Petal.Width":{"rv":1.6,"fv":"1.6","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6,"fv":"6","mi":3},"Sepal.Width":{"rv":3.4,"fv":"3.4","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"87"},"name":"87","id":"h87;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.7,"fv":"4.7","mi":0},"Petal.Width":{"rv":1.5,"fv":"1.5","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.7,"fv":"6.7","mi":3},"Sepal.Width":{"rv":3.1,"fv":"3.1","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"88"},"name":"88","id":"h88;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.4,"fv":"4.4","mi":0},"Petal.Width":{"rv":1.3,"fv":"1.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.3,"fv":"6.3","mi":3},"Sepal.Width":{"rv":2.3,"fv":"2.3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"89"},"name":"89","id":"h89;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.1,"fv":"4.1","mi":0},"Petal.Width":{"rv":1.3,"fv":"1.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.6,"fv":"5.6","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"90"},"name":"90","id":"h90;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4,"fv":"4","mi":0},"Petal.Width":{"rv":1.3,"fv":"1.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.5,"fv":"5.5","mi":3},"Sepal.Width":{"rv":2.5,"fv":"2.5","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"91"},"name":"91","id":"h91;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.4,"fv":"4.4","mi":0},"Petal.Width":{"rv":1.2,"fv":"1.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.5,"fv":"5.5","mi":3},"Sepal.Width":{"rv":2.6,"fv":"2.6","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"92"},"name":"92","id":"h92;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.6,"fv":"4.6","mi":0},"Petal.Width":{"rv":1.4,"fv":"1.4","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.1,"fv":"6.1","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"93"},"name":"93","id":"h93;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4,"fv":"4","mi":0},"Petal.Width":{"rv":1.2,"fv":"1.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.8,"fv":"5.8","mi":3},"Sepal.Width":{"rv":2.6,"fv":"2.6","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"94"},"name":"94","id":"h94;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":3.3,"fv":"3.3","mi":0},"Petal.Width":{"rv":1,"fv":"1","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5,"fv":"5","mi":3},"Sepal.Width":{"rv":2.3,"fv":"2.3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"95"},"name":"95","id":"h95;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.2,"fv":"4.2","mi":0},"Petal.Width":{"rv":1.3,"fv":"1.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.6,"fv":"5.6","mi":3},"Sepal.Width":{"rv":2.7,"fv":"2.7","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"96"},"name":"96","id":"h96;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.2,"fv":"4.2","mi":0},"Petal.Width":{"rv":1.2,"fv":"1.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.7,"fv":"5.7","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"97"},"name":"97","id":"h97;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.2,"fv":"4.2","mi":0},"Petal.Width":{"rv":1.3,"fv":"1.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.7,"fv":"5.7","mi":3},"Sepal.Width":{"rv":2.9,"fv":"2.9","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"98"},"name":"98","id":"h98;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.3,"fv":"4.3","mi":0},"Petal.Width":{"rv":1.3,"fv":"1.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.2,"fv":"6.2","mi":3},"Sepal.Width":{"rv":2.9,"fv":"2.9","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"99"},"name":"99","id":"h99;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":3,"fv":"3","mi":0},"Petal.Width":{"rv":1.1,"fv":"1.1","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.1,"fv":"5.1","mi":3},"Sepal.Width":{"rv":2.5,"fv":"2.5","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"100"},"name":"100","id":"h100;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"versicolor"},"name":"versicolor","id":"hversicolor;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.1,"fv":"4.1","mi":0},"Petal.Width":{"rv":1.3,"fv":"1.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.7,"fv":"5.7","mi":3},"Sepal.Width":{"rv":2.8,"fv":"2.8","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"101"},"name":"101","id":"h101;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":6,"fv":"6","mi":0},"Petal.Width":{"rv":2.5,"fv":"2.5","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.3,"fv":"6.3","mi":3},"Sepal.Width":{"rv":3.3,"fv":"3.3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"102"},"name":"102","id":"h102;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.1,"fv":"5.1","mi":0},"Petal.Width":{"rv":1.9,"fv":"1.9","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.8,"fv":"5.8","mi":3},"Sepal.Width":{"rv":2.7,"fv":"2.7","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"103"},"name":"103","id":"h103;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.9,"fv":"5.9","mi":0},"Petal.Width":{"rv":2.1,"fv":"2.1","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":7.1,"fv":"7.1","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"104"},"name":"104","id":"h104;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.6,"fv":"5.6","mi":0},"Petal.Width":{"rv":1.8,"fv":"1.8","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.3,"fv":"6.3","mi":3},"Sepal.Width":{"rv":2.9,"fv":"2.9","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"105"},"name":"105","id":"h105;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.8,"fv":"5.8","mi":0},"Petal.Width":{"rv":2.2,"fv":"2.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.5,"fv":"6.5","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"106"},"name":"106","id":"h106;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":6.6,"fv":"6.6","mi":0},"Petal.Width":{"rv":2.1,"fv":"2.1","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":7.6,"fv":"7.6","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"107"},"name":"107","id":"h107;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.5,"fv":"4.5","mi":0},"Petal.Width":{"rv":1.7,"fv":"1.7","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":4.9,"fv":"4.9","mi":3},"Sepal.Width":{"rv":2.5,"fv":"2.5","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"108"},"name":"108","id":"h108;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":6.3,"fv":"6.3","mi":0},"Petal.Width":{"rv":1.8,"fv":"1.8","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":7.3,"fv":"7.3","mi":3},"Sepal.Width":{"rv":2.9,"fv":"2.9","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"109"},"name":"109","id":"h109;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.8,"fv":"5.8","mi":0},"Petal.Width":{"rv":1.8,"fv":"1.8","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.7,"fv":"6.7","mi":3},"Sepal.Width":{"rv":2.5,"fv":"2.5","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"110"},"name":"110","id":"h110;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":6.1,"fv":"6.1","mi":0},"Petal.Width":{"rv":2.5,"fv":"2.5","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":7.2,"fv":"7.2","mi":3},"Sepal.Width":{"rv":3.6,"fv":"3.6","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"111"},"name":"111","id":"h111;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.1,"fv":"5.1","mi":0},"Petal.Width":{"rv":2,"fv":"2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.5,"fv":"6.5","mi":3},"Sepal.Width":{"rv":3.2,"fv":"3.2","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"112"},"name":"112","id":"h112;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.3,"fv":"5.3","mi":0},"Petal.Width":{"rv":1.9,"fv":"1.9","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.4,"fv":"6.4","mi":3},"Sepal.Width":{"rv":2.7,"fv":"2.7","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"113"},"name":"113","id":"h113;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.5,"fv":"5.5","mi":0},"Petal.Width":{"rv":2.1,"fv":"2.1","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.8,"fv":"6.8","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"114"},"name":"114","id":"h114;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5,"fv":"5","mi":0},"Petal.Width":{"rv":2,"fv":"2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.7,"fv":"5.7","mi":3},"Sepal.Width":{"rv":2.5,"fv":"2.5","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"115"},"name":"115","id":"h115;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.1,"fv":"5.1","mi":0},"Petal.Width":{"rv":2.4,"fv":"2.4","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.8,"fv":"5.8","mi":3},"Sepal.Width":{"rv":2.8,"fv":"2.8","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"116"},"name":"116","id":"h116;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.3,"fv":"5.3","mi":0},"Petal.Width":{"rv":2.3,"fv":"2.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.4,"fv":"6.4","mi":3},"Sepal.Width":{"rv":3.2,"fv":"3.2","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"117"},"name":"117","id":"h117;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.5,"fv":"5.5","mi":0},"Petal.Width":{"rv":1.8,"fv":"1.8","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.5,"fv":"6.5","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"118"},"name":"118","id":"h118;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":6.7,"fv":"6.7","mi":0},"Petal.Width":{"rv":2.2,"fv":"2.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":7.7,"fv":"7.7","mi":3},"Sepal.Width":{"rv":3.8,"fv":"3.8","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"119"},"name":"119","id":"h119;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":6.9,"fv":"6.9","mi":0},"Petal.Width":{"rv":2.3,"fv":"2.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":7.7,"fv":"7.7","mi":3},"Sepal.Width":{"rv":2.6,"fv":"2.6","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"120"},"name":"120","id":"h120;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5,"fv":"5","mi":0},"Petal.Width":{"rv":1.5,"fv":"1.5","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6,"fv":"6","mi":3},"Sepal.Width":{"rv":2.2,"fv":"2.2","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"121"},"name":"121","id":"h121;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.7,"fv":"5.7","mi":0},"Petal.Width":{"rv":2.3,"fv":"2.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.9,"fv":"6.9","mi":3},"Sepal.Width":{"rv":3.2,"fv":"3.2","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"122"},"name":"122","id":"h122;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.9,"fv":"4.9","mi":0},"Petal.Width":{"rv":2,"fv":"2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.6,"fv":"5.6","mi":3},"Sepal.Width":{"rv":2.8,"fv":"2.8","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"123"},"name":"123","id":"h123;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":6.7,"fv":"6.7","mi":0},"Petal.Width":{"rv":2,"fv":"2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":7.7,"fv":"7.7","mi":3},"Sepal.Width":{"rv":2.8,"fv":"2.8","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"124"},"name":"124","id":"h124;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.9,"fv":"4.9","mi":0},"Petal.Width":{"rv":1.8,"fv":"1.8","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.3,"fv":"6.3","mi":3},"Sepal.Width":{"rv":2.7,"fv":"2.7","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"125"},"name":"125","id":"h125;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.7,"fv":"5.7","mi":0},"Petal.Width":{"rv":2.1,"fv":"2.1","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.7,"fv":"6.7","mi":3},"Sepal.Width":{"rv":3.3,"fv":"3.3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"126"},"name":"126","id":"h126;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":6,"fv":"6","mi":0},"Petal.Width":{"rv":1.8,"fv":"1.8","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":7.2,"fv":"7.2","mi":3},"Sepal.Width":{"rv":3.2,"fv":"3.2","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"127"},"name":"127","id":"h127;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.8,"fv":"4.8","mi":0},"Petal.Width":{"rv":1.8,"fv":"1.8","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.2,"fv":"6.2","mi":3},"Sepal.Width":{"rv":2.8,"fv":"2.8","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"128"},"name":"128","id":"h128;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.9,"fv":"4.9","mi":0},"Petal.Width":{"rv":1.8,"fv":"1.8","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.1,"fv":"6.1","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"129"},"name":"129","id":"h129;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.6,"fv":"5.6","mi":0},"Petal.Width":{"rv":2.1,"fv":"2.1","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.4,"fv":"6.4","mi":3},"Sepal.Width":{"rv":2.8,"fv":"2.8","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"130"},"name":"130","id":"h130;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.8,"fv":"5.8","mi":0},"Petal.Width":{"rv":1.6,"fv":"1.6","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":7.2,"fv":"7.2","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"131"},"name":"131","id":"h131;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":6.1,"fv":"6.1","mi":0},"Petal.Width":{"rv":1.9,"fv":"1.9","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":7.4,"fv":"7.4","mi":3},"Sepal.Width":{"rv":2.8,"fv":"2.8","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"132"},"name":"132","id":"h132;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":6.4,"fv":"6.4","mi":0},"Petal.Width":{"rv":2,"fv":"2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":7.9,"fv":"7.9","mi":3},"Sepal.Width":{"rv":3.8,"fv":"3.8","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"133"},"name":"133","id":"h133;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.6,"fv":"5.6","mi":0},"Petal.Width":{"rv":2.2,"fv":"2.2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.4,"fv":"6.4","mi":3},"Sepal.Width":{"rv":2.8,"fv":"2.8","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"134"},"name":"134","id":"h134;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.1,"fv":"5.1","mi":0},"Petal.Width":{"rv":1.5,"fv":"1.5","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.3,"fv":"6.3","mi":3},"Sepal.Width":{"rv":2.8,"fv":"2.8","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"135"},"name":"135","id":"h135;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.6,"fv":"5.6","mi":0},"Petal.Width":{"rv":1.4,"fv":"1.4","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.1,"fv":"6.1","mi":3},"Sepal.Width":{"rv":2.6,"fv":"2.6","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"136"},"name":"136","id":"h136;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":6.1,"fv":"6.1","mi":0},"Petal.Width":{"rv":2.3,"fv":"2.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":7.7,"fv":"7.7","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"137"},"name":"137","id":"h137;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.6,"fv":"5.6","mi":0},"Petal.Width":{"rv":2.4,"fv":"2.4","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.3,"fv":"6.3","mi":3},"Sepal.Width":{"rv":3.4,"fv":"3.4","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"138"},"name":"138","id":"h138;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.5,"fv":"5.5","mi":0},"Petal.Width":{"rv":1.8,"fv":"1.8","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.4,"fv":"6.4","mi":3},"Sepal.Width":{"rv":3.1,"fv":"3.1","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"139"},"name":"139","id":"h139;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":4.8,"fv":"4.8","mi":0},"Petal.Width":{"rv":1.8,"fv":"1.8","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6,"fv":"6","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"140"},"name":"140","id":"h140;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.4,"fv":"5.4","mi":0},"Petal.Width":{"rv":2.1,"fv":"2.1","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.9,"fv":"6.9","mi":3},"Sepal.Width":{"rv":3.1,"fv":"3.1","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"141"},"name":"141","id":"h141;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.6,"fv":"5.6","mi":0},"Petal.Width":{"rv":2.4,"fv":"2.4","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.7,"fv":"6.7","mi":3},"Sepal.Width":{"rv":3.1,"fv":"3.1","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"142"},"name":"142","id":"h142;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.1,"fv":"5.1","mi":0},"Petal.Width":{"rv":2.3,"fv":"2.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.9,"fv":"6.9","mi":3},"Sepal.Width":{"rv":3.1,"fv":"3.1","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"143"},"name":"143","id":"h143;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.1,"fv":"5.1","mi":0},"Petal.Width":{"rv":1.9,"fv":"1.9","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.8,"fv":"5.8","mi":3},"Sepal.Width":{"rv":2.7,"fv":"2.7","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"144"},"name":"144","id":"h144;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.9,"fv":"5.9","mi":0},"Petal.Width":{"rv":2.3,"fv":"2.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.8,"fv":"6.8","mi":3},"Sepal.Width":{"rv":3.2,"fv":"3.2","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"145"},"name":"145","id":"h145;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.7,"fv":"5.7","mi":0},"Petal.Width":{"rv":2.5,"fv":"2.5","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.7,"fv":"6.7","mi":3},"Sepal.Width":{"rv":3.3,"fv":"3.3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"146"},"name":"146","id":"h146;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.2,"fv":"5.2","mi":0},"Petal.Width":{"rv":2.3,"fv":"2.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.7,"fv":"6.7","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"147"},"name":"147","id":"h147;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5,"fv":"5","mi":0},"Petal.Width":{"rv":1.9,"fv":"1.9","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.3,"fv":"6.3","mi":3},"Sepal.Width":{"rv":2.5,"fv":"2.5","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"148"},"name":"148","id":"h148;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.2,"fv":"5.2","mi":0},"Petal.Width":{"rv":2,"fv":"2","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.5,"fv":"6.5","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"149"},"name":"149","id":"h149;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.4,"fv":"5.4","mi":0},"Petal.Width":{"rv":2.3,"fv":"2.3","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":6.2,"fv":"6.2","mi":3},"Sepal.Width":{"rv":3.4,"fv":"3.4","mi":4}}}]},{"depth":0,"element":{"attributeIndex":0,"formValues":{"ID":"150"},"name":"150","id":"h150;D91B4BDE11E82EDC13FC0080EF25E205"},"isPartial":false,"children":[{"depth":1,"element":{"attributeIndex":1,"formValues":{"ID":"virginica"},"name":"virginica","id":"hvirginica;D91B6E0311E82EDC1D720080EF25E205"},"metrics":{"Petal.Length":{"rv":5.1,"fv":"5.1","mi":0},"Petal.Width":{"rv":1.8,"fv":"1.8","mi":1},"RowCount-iris.csv":{"rv":1,"fv":"1","mi":2},"Sepal.Length":{"rv":5.9,"fv":"5.9","mi":3},"Sepal.Width":{"rv":3,"fv":"3","mi":4}}}]}]}}}}'
    response = json.loads(response)
    return response


class TestParsejson(unittest.TestCase):

    def test_parsejson_columns(self):
        test_df = parsejson(response=get_response())
        expect_cols = ['ID', 'Species', 'Petal.Length', 'Petal.Width', 'RowCount-iris.csv', 'Sepal.Length', 'Sepal.Width']
        self.assertEquals(list(test_df.columns), expect_cols)

    def test_parsejson_sums(self):
        df = parsejson(response=get_response())
        df_sums = df.filter(items=['Petal.Length', 'Petal.Width', 'Sepal.Length', 'Sepal.Width']).sum(axis=0)
        self.assertAlmostEqual(sum(list(df_sums.values)), 2078.7, places=4)


if __name__ == '__main__':
    unittest.main()

